Public Member Functions

# wxPathList Class Reference
[File Handling]

`#include <wx/filefn.h>`

Inheritance diagram for wxPathList:
[legend]

## Detailed Description

The path list is a convenient way of storing a number of directories, and when presented with a filename without a directory, searching for an existing file in those directories.

Be sure to look also at wxStandardPaths if you only want to search files in some standard paths.

##

Library: wxBase
Category: File Handling

See also:
  wxArrayString, wxStandardPaths, wxFileName

## Public Member Functions
| wxPathList ()
| Standard constructor.
| wxPathList (const wxArrayString &arr)
| Constructs the object calling the Add() function.
bool | Add (const wxString &path)
| Adds the given directory to the path list, if the path is not already in the list.
void | Add (const wxArrayString &arr)
| Adds all elements of the given array as paths.
void | AddEnvList (const wxString &env_variable)
| Finds the value of the given environment variable, and adds all paths to the path list.
bool | EnsureFileAccessible (const wxString &filename)
| Given a full filename (with path), calls Add() with the path of the file.
wxString | FindAbsoluteValidPath (const wxString &file) const
| Like FindValidPath() but this function always returns an absolute path (eventually prepending the current working directory to the value returned wxPathList::FindValidPath()) or an empty string.
wxString | FindValidPath (const wxString &file) const
| Searches the given file in all paths stored in this class.

List of all members.

## Constructor & Destructor Documentation

wxPathList::wxPathList | ( |  | ) |

Standard constructor.

wxPathList::wxPathList | ( | const wxArrayString & | arr | ) |

Constructs the object calling the Add() function.

## Member Function Documentation

bool wxPathList::Add | ( | const wxString & | path | ) |

Adds the given directory to the path list, if the path is not already in the list.

If the path cannot be normalized for some reason, it returns false.

The path is always considered to be a directory but no existence checks will be done on it (because if it doesn't exist, it could be created later and thus result a valid path when FindValidPath() is called).

Note:
  if the given path is relative, it won't be made absolute before adding it (this is why FindValidPath() may return relative paths).

void wxPathList::Add | ( | const wxArrayString & | arr | ) |

Adds all elements of the given array as paths.

void wxPathList::AddEnvList | ( | const wxString & | env_variable | ) |

Finds the value of the given environment variable, and adds all paths to the path list.

Useful for finding files in the `PATH` variable, for example.

bool wxPathList::EnsureFileAccessible | ( | const wxString & | filename | ) |

Given a full filename (with path), calls Add() with the path of the file.

wxString wxPathList::FindAbsoluteValidPath | ( | const wxString & | file | ) | const

Like FindValidPath() but this function always returns an absolute path (eventually prepending the current working directory to the value returned wxPathList::FindValidPath()) or an empty string.

wxString wxPathList::FindValidPath | ( | const wxString & | file | ) | const

Searches the given file in all paths stored in this class.

The first path which concatenated to the given string points to an existing file (see wxFileExists()) is returned.

If the file wasn't found in any of the stored paths, an empty string is returned.

The given string must be a file name, eventually with a path prefix (if the path prefix is absolute, only its name will be searched); i.e. it must not end with a directory separator (see wxFileName::GetPathSeparator) otherwise an assertion will fail.

The returned path may be relative to the current working directory.

Note in fact that wxPathList can be used to store both relative and absolute paths so that if you added relative paths, then the current working directory (see wxGetCwd() and wxSetWorkingDirectory()) may affect the value returned by this function!

|  | [ top ]